# User Manual

## Root-Types
### Introduction
### Define new Root-Types
### Alter existing Root-Types

## How to work with the GUI
### GUI Overview

![Image][gui_overview]

Elements for Query-Creating
1. Buttons for saving/loading Queries
2. Buttons for Server Settings and sending Query
3. Dropdownbox for choosing the Root-Type
4. Tree for creating the query-constraints
5. List of all defined Fields of chosen root-type, checked fields will be requested and shown in result-table

Elements for Downloading
6. Buttons for Result-Table (Toggle Selection and Download selected Items)
7. Result-Table

Elements of Diagram
8. Dropdownbox for choosing type which will be shown in diagram
9. List for creating Substrings, which will shown in diagram
10. Diagram

Other
11. Statusbar, shows result-count (when query was sent)

### Create a Query

1. Choose a Root-Type using the Dropdownbox (see GUI Overview: 3)
  * Root-Types are defined as JSON-files, located at the `../datatypes` -folder
2. Create the query-constraints using the tree (see GUI Overview: 4)
  * click on `...`
  * choose a logical connective (AND/OR) or a type (depends on the chosen Root-Type)
  * you can choose a single type at the beginning, to create a very simple query
  * you can nest operations and types
  * if you choose a type, make sure you choose an operator and a value too
  * __use % for wildcards__
  * __delete a line (and its children) by using rightclick on this element__
3. Choose some fields for you query using the list (see GUI Overview: 5)
  * there are some fields you can't deselect (These are important for downloading files for this Root-Type)
  * if you don't choose any field, the server will give you all fields of this type
  * choose every field you want to use in the diagram

Example Query:

![Image][query_example]

### Send a Query

1. Click on the button "Server Settings" (see GUI Overview: 2)
  * type your username, password and host-address ( __including protocol__ , like http, https)
2. Click on the button "Send Query" (see GUI Overview: 2)
  * if no error occurs, the results will be shown in the Result-Table (see GUI Overview: 7) and the count of your Results will be shown at the statusbar (see GUI Overview: 11)

### Download Files

1. Select some results at the Result-Table (see GUI Overview: 7)
  * maybe use the "Toggle-Selection"-button (see GUI Overview: 6)
2. click the "Download Selected Items"-Button (see GUI Overview: 6)
  * a window for choosing a destination folder will appear
  * a spinner will appear at the single elements in the Result-Table, at the beginning of the download
  * the spinner disappears when the download is finished

### Use the Diagram

1. Choose one of your requested fields by using the Dropdownbox (see GUI Overview: 8)
2. Add some substrings to the List (see GUI Overview: 9) by clicking on `...`
  * delete substrings by rightclicking on them
  * its not case-sensitive
  * the diagram will update by itself

![Image][diagram_example]

[gui_overview] : https://mosel.cbs.mpg.de/xnat/xnat-scan-ambassador/raw/master/READMEimages/GUI_overview.png
[query_example] : https://mosel.cbs.mpg.de/xnat/xnat-scan-ambassador/raw/master/READMEimages/query_example.png
[diagram_example] : https://mosel.cbs.mpg.de/xnat/xnat-scan-ambassador/raw/master/READMEimages/diagram_example.png
